Next Previous Up Contents
Next: Examples
Up: tapquery: Queries a Table Access Protocol server
Previous: tapquery: Queries a Table Access Protocol server

### B.29.1 Usage

The usage of `tapquery` is

       stilts <stilts-flags> tapquery nupload=<count> ufmtN=<in-format>
                                      uploadN=<tableN> ucmdN=<cmds> ocmd=<cmds>
                                      omode=out|meta|stats|count|checksum|cgi|discard|topcat|samp|plastic|tosql|gui
                                      out=<out-table> ofmt=<out-format>
                                      upnameN=<adql-identifier> tapurl=<url-value>
                                      interface=tap1.0|tap1.1|cap auth=true|false
                                      adql=<query-text> parse=true|false
                                      sync=true|false maxrec=<nrow>
                                      destruction=<iso8601>
                                      executionduration=<seconds>
                                      compress=true|false
                                      upvotformat=TABLEDATA|BINARY|BINARY2
                                      language=<lang-name> poll=<millisec>
                                      progress=true|false
                                      delete=finished|never|always|now

If you don't have the `stilts` script installed, write "`java -jar stilts.jar`" instead of "`stilts`" - see Section 3. The available `<stilts-flags>` are listed in Section 2.1. For programmatic invocation, the Task class for this command is `uk.ac.starlink.ttools.task.TapQuerier`.

Parameter values are assigned on the command line as explained in Section 2.3. They are as follows:

`adql = <query-text>` (String)
  Astronomical Data Query Language string specifying the TAP query to execute. ADQL/S resembles SQL, so this string will likely start with "SELECT".
`auth = true|false` (Boolean)
  If true, then an attempt will be made to authenticate with the TAP service even if anonymous operation is permitted. If the service offers authentication, you will be asked for credentials.

  To use this option in non-interactive contexts, you may want to use the `auth.username` and `auth.password` system properties.

  [Default: `false`]

`compress = true|false` (Boolean)
  If true, the service is requested to provide HTTP-level compression for the response stream (Accept-Encoding header is set to "`gzip`", see RFC 2616). This does not guarantee that compression will happen but if the service honours this request it may result in a smaller amount of network traffic at the expense of more processing on the server and client.

  [Default: `true`]

`delete = finished|never|always|now` (DeleteMode)
  Determines under what circumstances the UWS job is to be deleted from the server when its data is no longer required. If it is not deleted, then the job is left on the TAP server and it can be accessed via the normal UWS REST endpoints or using `tapresume` until it is destroyed by the server.

  Possible values:

  - `finished`: delete only if the job finished, successfully or not
  - `never`: do not delete
  - `always`: delete on command exit
  - `now`: delete and return immediately

  [Default: `finished`]

`destruction = <iso8601>` (String)
  Posts an updated value of the UWS DESTRUCTION parameter to the query job before it starts. This only makes sense for asynchronous jobs (`sync`=false).

  The supplied value should be an ISO-8601-like string, giving the new requested job destruction time. The service is not obliged to honour this request. See UWS v1.0, sec 2.2.3.3.

`executionduration = <seconds>` (Long)
  Posts an updated value of the UWS EXECUTIONDURATION parameter to the query job before it starts. This only makes sense for asynchronous jobs (`sync`=false).

  The supplied value is an integer giving the maximum number of wall-clock seconds for which the job is permitted to execute before being forcibly terminated. A value of zero indicates unlimited duration. The service is not obliged to honour this request. See UWS v1.0, sec 2.2.3.4.

`interface = tap1.0|tap1.1|cap` (String)
  Defines how the service endpoints and the version of the TAP protocol to use for queries is determined. This may take one of the following (case-insensitive) values:
  - `TAP1.0`: The standard TAP endpoints are used, without examining the service's capabilities document. The service is queried using version 1.0 of the TAP protocol.
  - `TAP1.1`: The standard TAP endpoints are used, without examining the service's capabilities document. The service is queried using version 1.1 of the TAP protocol.
  - `cap`: The service's capabilities document is examined, and the endpoints listed there are used.

  The capabilities document, if used, is read from `tapurl`/capabilities unless the `capabilitiesurl` parameter is defined, in which case that is used.

  The baseline value of all the TAP service endpoints (`sync`, `async`, `tables`, `capabilities`, `examples`) are determined by this parameter, but each of those endpoint values may be overridden individually by other endpoint-specific parameters (`syncurl`, `asyncurl`, `tablesurl`, `capabilitiesurl`, `availabilityurl`, `examplesurl`)

  For default (unauthenticated) access, the default value is usually suitable.

  [Default: `tap1.0`]

`language = <lang-name>` (String)
  Language to use for the ADQL-like query. This will usually be "ADQL" (the default), but may be set to some other value supported by the service, for instance a variant indicating a different ADQL version. Note that at present, setting it to "PQL" is not sufficient to submit a PQL query.

  [Default: `ADQL`]

`maxrec = <nrow>` (Long)
  Sets the requested maximum row count for the result of the query. The service is not obliged to respect this, but in the case that it has a default maximum record count, setting this value may raise the limit. If no value is set, the service's default policy will be used.
`nupload = <count>` (Integer)
  The number of upload tables for this task. For each of the upload tables N there will be associated parameters `ufmtN`, `uploadN` and `ucmdN`.

  [Default: `0`]

`ocmd = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on the output table, after all other processing has taken place. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`ofmt = <out-format>` (String)
  Specifies the format in which the output table will be written (one of the ones in Section 5.1.2 - matching is case-insensitive and you can use just the first few letters). If it has the special value "`(auto)`" (the default), then the output filename will be examined to try to guess what sort of file is required usually by looking at the extension. If it's not obvious from the filename what output format is intended, an error will result.

  This parameter must only be given if `omode` has its default value of "`out`".

  [Default: `(auto)`]

`omode = out|meta|stats|count|checksum|cgi|discard|topcat|samp|plastic|tosql|gui` (ProcessingMode)
  The mode in which the result table will be output. The default mode is `out`, which means that the result will be written as a new table to disk or elsewhere, as determined by the `out` and `ofmt` parameters. However, there are other possibilities, which correspond to uses to which a table can be put other than outputting it, such as displaying metadata, calculating statistics, or populating a table in an SQL database. For some values of this parameter, additional parameters (`<mode-args>`) are required to determine the exact behaviour.

  Possible values are

  - `out`
  - `meta`
  - `stats`
  - `count`
  - `checksum`
  - `cgi`
  - `discard`
  - `topcat`
  - `samp`
  - `plastic`
  - `tosql`
  - `gui`
  Use the `help=omode` flag or see Section 6.4 for more information.

  [Default: `out`]

`out = <out-table>` (TableConsumer)
  The location of the output table. This is usually a filename to write to. If it is equal to the special value "-" (the default) the output table will be written to standard output.

  This parameter must only be given if `omode` has its default value of "`out`".

  [Default: `-`]

`parse = true|false` (Boolean)
  Determines whether an attempt will be made to check the syntax of the ADQL prior to submitting the query. If this is set true, and if a syntax error is found, the task will fail with an error before any attempt is made to submit the query.

  [Default: `false`]

`poll = <millisec>` (Integer)
  Interval to wait between polling attempts, in milliseconds. Asynchronous TAP queries can only find out when they are complete by repeatedly polling the server to find out the job's status. This parameter allows you to set how often that happens. Attempts to set it too low (<50) will be rejected on the assumption that you're thinking in seconds.

  [Default: `5000`]

`progress = true|false` (Boolean)
  If this parameter is set true, updates on the status of the asynchronous UWS job are reported to standard output as they become available. This parameter is ignored in synchronous mode.

  [Default: `true`]

`sync = true|false` (Boolean)
  Determines whether the TAP query is submitted in synchronous or asynchronous mode. Synchronous (`true`) means that the result is retrieved over the same HTTP connection that the query is submitted from. This is uncomplicated, but means if the query takes a long time it may time out and the results will be lost. Asynchronous (`false`) means that the job is queued and results may be retrieved later. Normally this command does the necessary waiting around and recovery of the result, though with appropriate settings you can get `tapresume` to pick it up for you later instead. In most cases `false` (the default) is preferred.

  [Default: `false`]

`tapurl = <url-value>` (URL)
  The base URL of a Table Access Protocol service. This is the bare URL without a trailing "/[a]sync".

  In the usual case, the default values of the various endpoints (sync and async query submission, tables metadata, service-provided examples etc) use this URL as a parent and append standard sub-paths.

  In some cases however, determination of the endpoints is more complicated, as determined by the `interface` parameter which may cause endpoints to be read from the capabilities document at `tapurl/capabilities`, and by other endpoint-specific parameters (`syncurl`, `asyncurl`, `tablesurl`, `capabilitiesurl`, `availabilityurl`, `examplesurl`) for fine tuning.

`ucmdN = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on upload table #N as specified by parameter `uploadN`, before any other processing has taken place. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`ufmtN = <in-format>` (String)
  Specifies the format of upload table #N as specified by parameter `uploadN`. The known formats are listed in Section 5.1.1. This flag can be used if you know what format your table is in. If it has the special value `(auto)` (the default), then an attempt will be made to detect the format of the table automatically. This cannot always be done correctly however, in which case the program will exit with an error explaining which formats were attempted. This parameter is ignored for scheme-specified tables.

  [Default: `(auto)`]

`uploadN = <tableN>` (StarTable)
  The location of upload table #N. This may take one of the following forms:
  - A filename.
  - A URL.
  - The special value "`-`", meaning standard input. In this case the input format must be given explicitly using the `ufmtN` parameter. Note that not all formats can be streamed in this way.
  - A scheme specification of the form `:<scheme-name>:<scheme-args>`.
  - A system command line with either a "`<`" character at the start, or a "`|`" character at the end ("`<syscmd`" or "`syscmd|`"). This executes the given pipeline and reads from its standard output. This will probably only work on unix-like systems.
  In any case, compressed data in one of the supported compression formats (gzip, Unix compress or bzip2) will be decompressed transparently.
`upnameN = <adql-identifier>` (String)
  Identifier to use in server-side expressions for uploaded table #N. In ADQL expressions, the table should be referred to as "`TAP_UPLOAD.<label>`".

  The value must syntactically be an ADQL identifier (`[A-Za-z][A-Za-z0-9_]*`).

  [Default: `upN`]

`upvotformat = TABLEDATA|BINARY|BINARY2` (uk.ac.starlink.votable.VOTableWriter)
  Determines how any uploaded tables will be serialized for transmission to the TAP server. The supplied string is the name of one of the defined VOTable serialization formats. The choice shouldn't affect any results, though it may affect required bandwidth, and some services may (though should not) have non-standard requirements for serialization format.

  [Default: `TABLEDATA`]

Next Previous Up Contents
Next: Examples
Up: tapquery: Queries a Table Access Protocol server
Previous: tapquery: Queries a Table Access Protocol server

STILTS - Starlink Tables Infrastructure Library Tool Set
Starlink User Note256
STILTS web page: http://www.starlink.ac.uk/stilts/
Author email: m.b.taylor@bristol.ac.uk
Mailing list: topcat-user@jiscmail.ac.uk